appointment/urls.py
from django.conf import settings
from django.contrib.auth import views as auth_views
from django.urls import path

from . import views

app_name = "appointments"

urlpatterns = [
    path("list-appointments/", views.list_appointment, name="list-appointments"),
    path("create-appointment/", views.create_appointment, name="create-appointment"),
    path("update-appointment/<str:pk>", views.update_appointment, name="update-appointment",),
    path("appointment/<str:pk>/start-consultation", views.start_consultation, name="start-consultation"),
#     path("show-details/<str:pk>", views.showDetails, name="show-details"),

]

patient/urls.py
from django.conf import settings
from django.contrib.auth import views as auth_views
from django.urls import path

from patient.views import updatePatient

from . import views

app_name = "patient"

urlpatterns = [
    path("patient-list/", views.patientList, name="patient-list"),
    path("show-details/<str:pk>", views.showDetails, name="show-details"),
    path("patient-register/", views.registerPatient, name="patient-register"),
    path("patient-update/<str:pk>", updatePatient, name="patient-update",),
]

project_config/urls.py
from django.conf import settings
from django.conf.urls import url
from django.conf.urls.static import static
from django.contrib import admin
from filebrowser.sites import site
from django.contrib.auth import views as auth_views
from django.urls import include, path

from . import views

urlpatterns = (
    [
        path('admin/filebrowser/', site.urls),
        path("admin/", admin.site.urls),
        path("", views.home, name="home"),
        path("", include("collaborator.urls", namespace="collaborator")),
        path("", include("patient.urls", namespace="patient")),
        path("", include("appointment.urls", namespace="appointments")),
    ]
    + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
    + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
)

appointment/models.py
import logging
import quopri
import random
import textwrap
import threading
import uuid
from datetime import timedelta
from email.mime.text import MIMEText

from django.core.mail import EmailMultiAlternatives, send_mail
from django.db import models
from django.utils import timezone
from django.utils.timezone import localtime
from django.utils.translation import gettext_lazy as _

from collaborator.models import Profile
from patient.models import Patient

logger = logging.getLogger('django')


class NotificationPatient(models.Model):
    NOTIFICATION_MODEL_ACTION = (
        ('appointment-saved', _('Notify to pacientes appointments')),
    )

    class Meta:
        db_table = 'NotificationSupportTeam'
        verbose_name = _('Notification Support Team')
        verbose_name_plural = _('Notification Support Team')

    action = models.CharField(max_length=200, choices=NOTIFICATION_MODEL_ACTION, verbose_name=_('Action'))
    patient = models.ForeignKey(Patient, on_delete=models.DO_NOTHING, verbose_name=_('Patient'))

    def __str__(self):
        return self.patient.name
    # def get_type_pacient(self):
    #     return "; ".join([p.name for p in self.patient.all()])


class TypeAppointment(models.Model):
    class Meta:
        db_table = "typeAppointment"
        verbose_name = _("typeAppointment")
        verbose_name_plural = _("typeAppointment")

    name = models.CharField(max_length=200, verbose_name=_('Name'))
    skip = models.BooleanField(default=False, verbose_name=_('Skip'))
    price = models.DecimalField(max_digits=5, decimal_places=2, verbose_name=_('Price of appointment'))
    updateAt = models.DateTimeField(null=False, blank=False, editable=False, auto_now=True)
    createAt = models.DateTimeField(null=False, blank=False, editable=False, auto_now_add=True)

    def __str__(self):
        return self.name


class Appointment(models.Model):
    class Meta:
        db_table = "appointment"
        verbose_name = _("appointment")
        verbose_name_plural = _("appointment")

    description = models.CharField(max_length=60, null=True, default=None, verbose_name=_('Appointment name'))
    type_appointment = models.ManyToManyField(TypeAppointment,
                                              verbose_name=_('Type appointment'))
    patient = models.ForeignKey(Patient, on_delete=models.PROTECT, verbose_name=_('Patient'))
    professional = models.ForeignKey(Profile, on_delete=models.DO_NOTHING, verbose_name=_('Professional'))
    date_appointment = models.DateTimeField(verbose_name=_('date of appointment'))
    consulting = models.BooleanField(default=False, verbose_name=_('Consulting'))
    isCanceled = models.BooleanField(default=False, editable=False)
    calendarUUID = models.UUIDField(default=uuid.uuid4, editable=False)
    calendarOwnerTID = models.IntegerField(default=random.randrange(-214748364, 2147483647), editable=False)
    updateAt = models.DateTimeField(null=False, blank=False, editable=False, auto_now=True)
    createAt = models.DateTimeField(null=False, blank=False, editable=False, auto_now_add=True)

    @property
    def date_now(self):
        now = timezone.now()
        return now < self.date_appointment

    # def get_type_appointment(self):
    #     return "\n".join([p.name for p in self.type_appointment.all()])

    def type_appointment_list(self):
        return ', '.join([str(i) for i in self.type_appointment.all()])

    def save(self, *args, **kwargs):
        super(Appointment, self).save(*args, **kwargs)
        if self.patient.email and self.createAt:
            self.start = threading.Thread(target=self.__send_invite_ics(), args=()).start()

    def __send_invite_ics(self):
        if not self.patient.email:
            logger.warning('Patient email is empty')
            return

        try:
            email_message = '\n'.join([
                'Você possui um consulta marcada com a Mirabolante Dente',
                '{0}: {1}'.format('Consulta', self.description),
                '{0}: {1}'.format('Endereço',
                                  '<Mirabolante Dente>, CNA 01 Lote 09/10 Ed. Santos Dumond Salas 501 e 502, '
                                  'Taguatinga Norte, Brasília - DF, 72110-015'),
                '{0}: {1}'.format('Responsável pela Consulta', self.professional),
                '{0}: {1}'.format('Email do responsavel', 'www.mirabolantedente.net.com.br'),
                '{0}: {1}'.format('Seu Atendimento será dia',
                                  localtime(self.date_appointment).strftime('%d/%m/%Y %H:%M')),
            ])
            email = EmailMultiAlternatives(
                '{0} - {1}'.format(self.description, 'cancelado' if not self.date_now else 'marcado'),
                email_message, 'Mirabolante Dente <www.mirabolantedente.net.com.br>',
                to=[self.patient.email],
            )

            # Form more information read https://tools.ietf.org/html/rfc5545
            vcalendar = [
                'BEGIN:VCALENDAR',
                'PRODID:-//Mirabolante Dente//controlpoint.app//EN',
                'VERSION:2.0',
                'CALSCALE:GREGORIAN',
                'METHOD:{0}'.format('CANCEL' if self.isCanceled else 'REQUEST'),
                'BEGIN:VEVENT',
                'DTSTART:{0}'.format(localtime(self.date_appointment + timedelta(hours=3)).strftime('%Y%m%dT%H%M%SZ')),
                'DTSTAMP:{0}'.format(localtime(self.createAt + timedelta(hours=3)).strftime('%Y%m%dT%H%M%SZ')),
                'LAST-MODIFIED:{0}'.format(localtime(self.updateAt + timedelta(hours=3)).strftime('%Y%m%dT%H%M%SZ')),
                'ORGANIZER;CN={0}:MAILTO:{1}'.format('Mirabolante Dente', 'cicerooliveira091@gmail.com'),
                'UID:{0}@control-point.app'.format(self.calendarUUID.hex.lower()),
                *['ATTENDEE;CUTYPE=INDIVIDUAL;ROLE=REQ-PARTICIPANT;PARTSTAT=NEEDS-ACTION;RSVP='
                  'TRUE;CN={0};X-NUM-GUESTS=0:mailto:{0}'.format(g) for g in self.patient.email],
                'X-MICROSOFT-CDO-OWNERAPPTID:{0}'.format(self.calendarOwnerTID),
                'SEQUENCE:{0}'.format('1' if self.isCanceled else '0'),
                'STATUS:{0}'.format('CANCELLED' if self.isCanceled else 'CONFIRMED'),
                'SUMMARY:{0}'.format(self.description),
                'TRANSP:OPAQUE',
                'END:VEVENT',
                'END:VCALENDAR',
            ]
            text_wrap = textwrap.TextWrapper(width=75)
            text_calendar = '\n'.join(['\n '.join(text_wrap.wrap(text=i)) for i in vcalendar])

            # first create MIMEBase, then set content-transfer-encoding, then set payload
            # don't forget add in content-type header the flag method=REQUEST
            calendar = MIMEText('text', 'calendar')
            calendar.set_payload(quopri.encodestring(bytes(text_calendar.encode('utf8'))), charset='utf-8')
            calendar.replace_header('Content-Transfer-Encoding', 'quoted-printable')
            calendar.replace_header('Content-Type', 'text/calendar; charset="utf-8"; method={0}'
                                    .format('CANCEL' if self.isCanceled else 'REQUEST'))

            email.attach(calendar)
            email.attach('invite.ics', text_calendar, 'application/ics')

            email.send(fail_silently=False)
            logger.info('Email sent')
        except Exception as e:
            logger.error("Send email error", exc_info=e)

    def __notify_patient_action_saved(self):
        query_set_patient = Appointment.objects.values(
            'patient__email')
        patients = [e.get('patient__email')
                    for e in query_set_patient if e.get('patient__email', False)]
        if len(patients) < 1:
            return

        email_message = '\n'.join([
            'Você possui um consulta marcada com a Mirabolante Dente',
            '{0}: {1}'.format('Consulta', self.description),
            '{0}: {1}'.format('Endereço',
                              '<Mirabolante Dente>, CNA 01 Lote 09/10 Ed. Santos Dumond Salas 501 e 502, '
                              'Taguatinga Norte, Brasília - DF, 72110-015'),
            '{0}: {1}'.format('Responsável pela Consulta', self.professional),
            '{0}: {1}'.format('Email do responsavel', 'www.mirabolantedente.net.com.br'),
            '{0}: {1}'.format('Seu Atendimento será dia', localtime(self.date_appointment).strftime('%d/%m/%Y %H:%M')),
        ])

        if self.createAt:
            try:
                send_mail(
                    '{0}'.format(self.patient.name),
                    email_message,
                    'Mirabolante Dente <www.mirabolantedente.net.com.br>',
                    patients
                )
                logger.info('Notify patients success')
            except Exception as e:
                logger.error('Notify patients error', exc_info=e)

appointment/views.py
import logging

from django.contrib import messages
from django.contrib.auth.decorators import login_required
from django.core.paginator import Paginator, PageNotAnInteger, EmptyPage
from django.db.models import Sum
from django.shortcuts import render, redirect
from django.utils.translation import gettext_lazy as _
from django.views.decorators.http import require_GET

from appointment.admin import Appointment
from appointment.form import AppointmentForm, FilterForm
from appointment.models import Appointment

logger = logging.getLogger("django")


@login_required
def create_appointment(request):
    form = AppointmentForm()
    if request.method == "POST":
        form = AppointmentForm(request.POST)
    try:
        if form.is_valid():
            form.save()
            messages.success(request, _("Appointment was successfully created!"))
            return redirect("appointments:list-appointments")
        else:
            context = {"form": form}
            return render(request, "appointment/create-appointments.html", context)
    except Exception:
        messages.warning(request, _("Error Form"))


@require_GET
def show_total_values(request):
    appointments = Appointment.objects.all()
    return appointments


@login_required
def list_appointment(request):
    form_filter = {}
    search = request.GET.get("search")
    big_filter = FilterForm(request.GET)

    if big_filter.is_valid():
        form_filter = big_filter.cleaned_data
    if form_filter.get("date_appointment"):
        appointments = Appointment.objects.filter(
            date_appointment=form_filter.get("date_appointment")).annotate(total=Sum("type_appointment__price"))

    elif search:
        appointments = Appointment.objects.filter(
            patient__name__icontains=search).annotate(total=Sum("type_appointment__price"))
    else:
        appointments = (
            Appointment.objects.all().annotate(total=Sum("type_appointment__price")).order_by("patient")
        )

        paginator = Paginator(appointments, 5)
        page = request.GET.get("page", 1)
        try:
            appointments = paginator.get_page(page)
        except PageNotAnInteger:
            appointments = paginator.get_page(2)
        except EmptyPage:
            appointments = paginator.get_page(paginator.num_pages)
    context = {
        "appointments": appointments,
        "show_total_values": show_total_values(request),
    }
    return render(request, "appointment/list-appointments.html", context)


@login_required
def update_appointment(request, pk):
    appointment = Appointment.objects.get(id=pk)
    if request.method == "POST":
        form = AppointmentForm(request.POST, instance=appointment)
        if form.is_valid():
            form.save()
            messages.success(request, _("Dados da consulta de {0} foi atualizada com sucesso!"
                                        .format(appointment.patient)))
            return redirect("appointments:list-appointments")
        else:
            messages.warning(request, _("Please correct the error below."))
    else:
        form = AppointmentForm(instance=appointment)
        context = {"form": form}
        return render(request, "appointment/create-appointments.html", context)


@require_GET
@login_required
def start_consultation(request, pk):
    a = Appointment.objects.get(id=pk)

    if not a.consulting:
        a.consulting = True
        a.save()
        messages.success(
            request, _("A consulta com o (a) {0} foi iniciada ".format(a.patient))
        )
    else:
        a.consulting = False
        a.save()
        messages.success(
            request, _("A consulta com o (a) {0} foi finalizada".format(a.patient))
        )
    return redirect("appointments:list-appointments")

appointment/templates/appointment/create-appointments.html
{% extends 'base/base.html' %}
{% block content %}
{% load static %}

<div class="row wrapper border-bottom bg-white page-heading" style="margin-bottom: 30px;">
    <div class="col-lg-10">
        <h2 class="text-muted profile">Formulario de cadastro consultas</h2>
    </div>
</div>
<form action="" method='POST' novalidate>
    {% csrf_token %}
    <div class="col-md-12">
        <div class="row">
            <div class="col-12">
                <div class="form-group">
                    <label class="sr-only">Descrição da consulta</label>
                    {{ form.description }}
                </div>
            </div>

            <div class="col-12">
                <div class="form-group">
                    <label class="sr-only">Tipos de consulta</label>
                    {{ form.type_appointment }}
                </div>
            </div>
            <div class="col-12">
                <div class="form-group">
                    <label class="sr-only">Paciente</label>
                    {{ form.patient }}
                </div>

            </div>

            <div class="col-12">
                <div class="form-group">
                    <label class="sr-only">professional</label>
                    {{ form.professional }}
                </div>
            </div>

            <div class="col-12">
                <div class="form-group">
                    <label class="sr-only">date_appointment</label>
                    {{ form.date_appointment }}
                </div>
            </div>
        </div>
        <button class='btn btn-info' type='submit'>Salvar</button>
    </div>
    </div>
</form>
{% endblock %}

appointment/templates/appointment/home-cards.html
<!DOCTYPE html>
{% load static %}

<link rel="stylesheet" href="{% static 'dist/css/cards-home.css' %}">
<link href="//maxcdn.bootstrapcdn.com/bootstrap/4.1.1/css/bootstrap.min.css" rel="stylesheet" id="bootstrap-css">
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.css" />
<html lang="en">


{% block body %}
<div class="container">
    <div class="row">
    <div class="col-md-3">
      <div class="card-counter primary">
        <i class="fa fa-code-fork"></i>
        <span class="count-numbers">12</span>
        <span class="count-name">Total consultas Hoje</span>
      </div>
    </div>

    <div class="col-md-3">
      <div class="card-counter danger">
        <i class="fa fa-ticket"></i>
        <span class="count-numbers">{{ show_total_values|length }}</span>
        <span class="count-name">Consultas</span>
      </div>

    </div>

    <div class="col-md-3">
      <div class="card-counter success">
        <i class="fa fa-database"></i>
        <span class="count-numbers">15</span>
        <span class="count-name">Este mês</span>
      </div>
    </div>

    <div class="col-md-3">
      <div class="card-counter info">
        <i class="fa fa-users"></i>
        <span class="count-numbers">35</span>
        <span class="count-name">Mês Passado</span>
      </div>
    </div>
  </div>
</div>
<script src="//maxcdn.bootstrapcdn.com/bootstrap/4.1.1/js/bootstrap.min.js"></script>
<script src="//cdnjs.cloudflare.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>
{% endblock %}

appointment/templates/appointment/list-appointments.html
{% extends 'base/base.html' %} {% load static %} {% block content %}

<div class="row wrapper border-bottom bg-white page-heading" style="margin-bottom: 30px;">
    <div class="col-lg-10">
        <h2 class="text-muted profile">Lista de consultas agendadas</h2>
    </div>
    <p class="btn btn-info btn-sm" style="float:right;" type="button">
        Total de consultas <span class="badge badge-light" style="font-size:14px; margin-left:10px;">
            {{ show_total_values|length }}</span>
    </p>
</div>
<div class="container">
    <form method="GET">
        <div class="col-12">
            <div class="row">
                <div class="form-group">
                    <a class="btn btn-info" href="{% url 'appointments:create-appointment'%}"
                       style="margin-bottom: 10px;">
                        Cadastrar nova consulta</a>
                </div>

                <div class="form-group col-md-4">
                    <label class="sr-only" for="search"></label>
                    <input class="form-control" id="search" name="search" placeholder="Pesquisar por nome do paciente" type="text"
                           value="{{ request.GET.search }}">
                </div>
                <div class="form-group col-md-4">
                    <label class="sr-only" for="date_appointment">Data do agendamento</label>
                    <input autocomplete="off" class="form-control datetimepicker" id="date_appointment" name="date_appointment"
                           placeholder="Pesquisar por data de agendamento" type="text"
                           value="{{ form.date_appointment | date:'d/m/Y H:i' }}">
                </div>
                <div class="form-group">
                    <button class="btn btn-primary mb-2" type="submit">Pesquisar</button>
                </div>
            </div>
        </div>
    </form>
</div>

<div class="row my-reserve">
    {% for appointment in appointments %}
    <div class="col-sm-12">
        <div class="card">
            <div class="card-body">
                <h5 class="card-title ">{{ appointment.patient }} <span class="badge {% if appointment.date_now %}badge-success
                        {% else %} badge-danger {% endif %}">
                        {% if appointment.date_now %} Consulta agendada
                        {% else %} Consulta cancelada{% endif %}</span>
                </h5>

                Número do prontuario: <b>{{appointment.patient.medical_record_number}}</b></br>
                Medico responsavel: <b>{{ appointment.professional }}</b>
                <p class="card-text">Data da consulta: <b>{{ appointment.date_appointment | date:'d/m/Y H:i' }}</b>
                </p>
                <ul>
                    {% for appointment in appointment.type_appointment.all %}
                    <li> Tipo de consulta: <b>{{ appointment.name }}</b> $ {{ appointment.price }}</li>
                    {% endfor %}
                </ul>
                <h5><span class="badge  badge-secondary" style="float:right">
                        Total: $ {{ appointment.total }}</span>
                </h5>
                <a class="btn btn-info fa fa-edit" href="{% url 'appointments:update-appointment' appointment.id %}"
                   title="Editar consulta"></a>
                {% if appointment.date_now %}
                <a class="btn btn-secondary fa fa-check"
                   href="{% url 'appointments:start-consultation' appointment.id %}" title="Iniciar consulta"></a>
                {% endif %}
                {% if appointment.consulting and appointment.date_now %}
                <span class="text-success">Paciente em atendimento</span>
                {% endif %}
            </div>
        </div>
    </div>
    {% endfor %}
    {% if not appointments %}
    <div class="col-md-6 offset-4">
        <div class="alert alert-warning" role="alert ">Nenhuma consulta cadastrada.</div>
    </div>
    {% endif %}
</div>

</div>
{% if appointments.has_other_pages %}
<nav aria-label="Page navigation example">
    <ul class="pagination justify-content-center">
        {% if appointments.has_previous %}
        <li class="page-item">
            <a aria-label="Previous" class="page-link" href="?page={{ appointments.previous_page_number }}">
                <span aria-hidden="true">&laquo;</span>
                <span class="sr-only">Previous</span>
            </a>
        </li>
        {% else %}
        <li class="page-item disabled">
            <a class="page-link" href="#" tabindex="-1">&laquo;</a>
        </li>
        {% endif %}
        {% for i in appointments.paginator.page_range %}
        {% if appointments.number == i %}
        <li class="page-item active">
            <a class="page-link" href="#">{{ i }} <span class="sr-only">(current)</span></a>
        </li>
        {% else %}
        <li><a href="?page={{ i }}">{{ i }}</a></li>
        {% endif %}
        {% endfor %}
        {% if appointments.has_next %}
        <li class="page-item">
            <a aria-label="Next" class="page-link" href="?page={{ appointments.next_page_number }}">
                <span aria-hidden="true">&raquo;</span>
                <span class="sr-only">Next</span>
            </a>
        </li>
        {% else %}
        <li class="page-item disabled">
            <a class="page-link" href="#" tabindex="-1">&raquo;</a>
        </li>
        {% endif %}
        <span current="current" style="margin-left:12px;">
            {{ appointments.number }} de {{ appointments.paginator.num_pages }}
        </span>

    </ul>
</nav>
{% endif %}
{% endblock %}